package cn.nhyw.xxpzgl.action;


import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import cn.base.aspect.OperateType;
import cn.base.bean.BaseAction;
import cn.base.bean.BeanHelper;
import cn.base.conf.ModuleConfFactory;
import cn.base.excel.ExcelCol;
import cn.base.excel.ExportEngine;
import cn.base.tinyftp.TinyFtpCfgInfo;
import cn.base.util.CommUtils;
import cn.base.util.Constants;
import cn.base.util.DateUtil;
import cn.base.util.FTPUrl;
import cn.base.util.FTPUtil;
import cn.base.util.FileCopyUtil;
import cn.base.util.LogConstants;
import cn.base.util.RHUtil;
import cn.base.util.StringUtil;
import cn.base.util.Struts2Utils;
import cn.bsystem.ptuserrole.model.PtyhBean;
import cn.nhyw.xxpzgl.service.NhywxmglwdxxService;

@SuppressWarnings({"all"})
@Component("nhywxmglwdxxAction")
public class NhywxmglwdxxAction extends BaseAction{
	private static final long serialVersionUID = 1L;
	private static Logger iLog = Logger.getLogger(NhywxmglwdxxAction.class);
	private static FTPUrl ftp = null;
	private File file;
	private String fileContentType;
	private String fileFileName;

	public File getFile() {
		return file;
	}
	public String getFileContentType() {
		return fileContentType;
	}
	public String getFileFileName() {
		return fileFileName;
	}
	public void setFile(File file) {
		this.file = file;
	}
	public void setFileContentType(String fileContentType) {
		this.fileContentType = fileContentType;
	}
	public void setFileFileName(String fileFileName) {
		this.fileFileName = fileFileName;
	}
	
	

	@Autowired
	private NhywxmglwdxxService service;
	
	/**
	 * 分页
	 */
	@OperateType(value = LogConstants.LOG_QUERY ,info ="listNhywxmglwdxxByPage")
	public void listNhywxmglwdxxByPage(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listNhywxmglwdxxByPage(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywxmglwdxxAction-listNhywxmglwdxxByPage-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 查询总数
	 */
	@OperateType(value = LogConstants.LOG_QUERY ,info ="count_Nhywxmglwdxx")
	public void count_Nhywxmglwdxx(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_Nhywxmglwdxx(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywxmglwdxxAction-count_Nhywxmglwdxx-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 查询 Nhywxmglwdxx
	 */
	@OperateType(value = LogConstants.LOG_GET ,info ="query_Nhywxmglwdxx")
	public void query_Nhywxmglwdxx(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.query_Nhywxmglwdxx(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywxmglwdxxAction-query_Nhywxmglwdxx-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 查询 一条Nhywxmglwdxx
	 */
	@OperateType(value = LogConstants.LOG_GET ,info ="get_Nhywxmglwdxx")
	public void get_Nhywxmglwdxx(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.get_Nhywxmglwdxx(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywxmglwdxxActionquery_Nhywxmglwdxx-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="deleteNhywxmglwdxx")
	public void delete_Nhywxmglwdxx(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!CommUtils.isEmpty(map)){
				String wdsclj = (String) map.get("wdsclj");
				String kz1 = (String) map.get("kz1");
				if(RHUtil.isNotEmpty(kz1) && !"null".equals(kz1)) {
					FTPUtil.deleteFileFromFtpUrl(kz1);
				}
				if(RHUtil.isNotEmpty(wdsclj) && !"null".equals(wdsclj)) {
					boolean flag = FTPUtil.deleteFileFromFtpUrl(wdsclj);
				}
//				System.out.println("删除ftp文件： "+wdsclj+"   "+flag);
				int result = service.delete_Nhywxmglwdxx(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}else{
				 throw new Exception("请正确的选择删除记录!!!");
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywxmglwdxxAction-delete_Nhywxmglwdxx-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	

	/**
	 * 插入
	 */
	@OperateType(value = LogConstants.LOG_ADD ,info ="insert_Nhywxmglwdxx")
	public void insert_Nhywxmglwdxx(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(StringUtil.checkEmpty(map.get("xh"))){
				map.put("xh",StringUtil.getUUID());
			}			 
		//	String fileName = file.getName();
		
			/*
			 测试上传 写入本地
			System.out.println("文件名=================： "+file.getAbsolutePath());
			System.out.println("文件名=================： "+fileName);
			System.out.println("文件名=================： "+fileFileName);
			System.out.println("文件名=================： "+fileContentType);

			InputStream inputStream = null;
			String uuid = StringUtil.getUUID();
		
	        String rootpath = ModuleConfFactory.getInstance().getScatter().getDownPath(); // private.xml中读取文件存放路径
	        String path = rootpath+uuid+"\\";
	        File tempPathFile = new File(path);
			if (!tempPathFile.exists()) {
				tempPathFile.mkdirs();
			}
			int isSuccess = 0;
			
			inputStream = new FileInputStream(file);
			isSuccess  = FileCopyUtil.copy(inputStream, new BufferedOutputStream(new FileOutputStream(path+fileFileName)));
		*/
			
			/*String path = "nhyw";
			String uuid = StringUtil.getUUID();
			String suf = fileFileName.substring(fileFileName.lastIndexOf("."));
			ftp = getFtpConfig();
			String fileUrl ="ftp://" + ftp.getFtpIp()+":"+ftp.getFtpPort()+"/"+path+"/"+uuid+suf;			
			FTPUtil.uploadFile(ftp, path, uuid+suf, new FileInputStream(file));			
			System.out.println("文件路径："+fileUrl);*/
			
		
			/*map.put("wdsclj", fileUrl);
			map.put("wdmc", fileFileName);*/
		
			
			PtyhBean ptyh = (PtyhBean)Struts2Utils.getSession().getAttribute("userInfo");
			map.put("wdscr", ptyh.getYhzh());
			map.put("wdscdw", ptyh.getBmbh());
			map.put("wdscsj", DateUtil.currentDateTime());		
			service.insert_Nhywxmglwdxx(map);	
			Struts2Utils.renderJson("success");
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywxmglwdxxAction-insert_Nhywxmglwdxx()-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	public FTPUrl getFtpConfig() throws Exception {
		System.out.println("进入===============");
		if (ftp == null) {
			List<TinyFtpCfgInfo> list = BeanHelper.getModuleConfFactory().getFtps().getimpywTinyFtpCfgInfoList();
			if(RHUtil.isNotEmpty(list)) {
				TinyFtpCfgInfo tfci = list.get(0);
				String ip = tfci.getFtpServerHost();
				String port = tfci.getFtpServerPort();
				String user = tfci.getLoginName();
				String password = tfci.getLoginPasword();
				ftp = new FTPUrl(ip,Integer.parseInt(port),user,password);
			}			
		}
		return ftp;
	}
	
	/**
	 * 修改
	 */
	@OperateType(value = LogConstants.LOG_UPDATE ,info ="update_Nhywxmglwdxx")
	public void update_Nhywxmglwdxx(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			
			String wdljurl = (String) map.get("wdsclj");
			if(RHUtil.isNotEmpty(wdljurl)) {				// 是否重新上传过文档
				String xh = (String) map.get("XGTJxh");
				Map cxMap = new HashMap();
				cxMap.put("xh", xh);
				Map res = service.get_Nhywxmglwdxx(cxMap);
				if(RHUtil.isNotEmpty(res)) {
					String wdsclj = (String) res.get("wdsclj");
					if(RHUtil.isNotEmpty(wdsclj)) {
						FTPUtil.deleteFileFromFtpUrl(wdsclj);				// 删除原上传文件
					}
					String kz1 = (String) res.get("kz1");
					if(RHUtil.isNotEmpty(kz1)) {
						FTPUtil.deleteFileFromFtpUrl(kz1);				// 删除原上传文件
					}
				}
			}
			
			int result = service.update_Nhywxmglwdxx(map);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywxmglwdxxAction-update_Nhywxmglwdxx-error: " +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 批量删除
	 */
	/*
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_delete_Nhywxmglwdxx")
	public void batch_delete_Nhywxmglwdxx(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Map m = new HashMap();
			m.put("keyword", map.get("keyword").toString());
			int result = service.batch_delete_Nhywxmglwdxx(m);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywxmglwdxxAction-batch_delete_Nhywxmglwdxx-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 导出Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_EXPORT ,info ="exp_Nhywxmglwdxx")
	public void exp_Nhywxmglwdxx(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			map.put("start",0 );
			map.put("limit",5000);
			List<Map> sList = service.query_Nhywxmglwdxx(map);		
			List<HashMap> expList = new ArrayList<HashMap>();
			for(Map m : sList){
				Map exportMap = new HashMap();
				exportMap.put("yhzh", m.get("yhzh"));
				expList.add((HashMap) exportMap);
			}
			int excelNum = 2;
			ExcelCol[] cells = new ExcelCol[excelNum];
			String[] zdbm = {"yhzh", "yhmc",};
			String[] zdmc = {"用户账号", "用户名称"};
			for(int i=0;i<excelNum;i++){
				cells[i] = new ExcelCol();
				cells[i].setColKey(zdbm[i]);
				cells[i].setColName(zdmc[i]);
			}		
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
        	String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "项目关联文档信息-"+dateTime);
			params.put("sheetName", "项目关联文档信息");
			params.put("header", "项目关联文档信息");	
			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywxmglwdxxAction-exoprtExcel-error:" +e);
			
		}
	}
	*/
	
	/**
	 * 导入Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_IMPORT ,info ="imp_Nhywxmglwdxx")
	public String imp_Nhywxmglwdxx(String excelFile,Object user) {
		String rs = "导入格式有误!";
		int rowNum = 0;
		int dataCount = 0;
		int successNum = 0;
		int repeatNum = 0;
		int failNum = 0;
		try {
		
			ExcelReader readExcel = new ExcelReader();
			readExcel.openFile(excelFile);
			readExcel.setSheetNum(0);
			int count = readExcel.getRowCount();
			iLog.info("总行数count--->" + count);
			rs = " 导入数据成功！总共"+ dataCount +"条数据,重复"+repeatNum+"条数据！失败"+failNum+"条数据!";
			File file = new File(excelFile);
			if(file.exists()){
				file.delete();
			}
		} catch (Exception e) {
			if (rowNum > 3) {
				rs = "资源部分导入(更新)失败！Excel第" + rowNum + "行起未导入(更新)成功！";
			} else {
				rs = "资源导入(更新)失败！";
			}
			iLog.error("NhywxmglwdxxAction-imp_Nhywxmglwdxx-error:" +e);
			e.printStackTrace();
		}		
		return rs;
	}
	*/
}
